<?php
/*
Plugin Name: Rusvc Notifier
Plugin URI: http://ivbutusov.ru/
Description: Показывает поверх сайта окошко с объявлением
Author: Илья Бутусов
Author URI: http://ivbutusov.ru/
Version: 1.2
*/

add_action('admin_menu', 'rusvc_notifier_admin');
add_action('admin_init', 'rusvc_notifier_init');

function rusvc_notifier_admin() {
    $h_admin = add_dashboard_page('Настройка объявления', 'Всплывающее объявление', 'manage_options', 'rusvc_notifier_options', 'rusvc_notifier_options');
    add_action('admin_print_scripts-' . $h_admin, 'rusvc_notifier_admin_js');
}

function rusvc_notifier_admin_js() {
    wp_enqueue_script('rusvc_notifier_admin_js');
}

function rusvc_notifier_init() {
    register_setting( 'rusvc-notifier', 'rusvc-notifier-data');
    wp_register_script('rusvc_notifier_admin_js', plugins_url('admin.js', __FILE__), array('jquery'));
}

function rusvc_notifier_res() {
    wp_enqueue_script('rusvc_notifier_script', plugins_url('notifier.js', __FILE__));
    wp_enqueue_style('rusvc_notifier_style', plugins_url('notifier.css', __FILE__));
}
add_action('wp_enqueue_scripts', 'rusvc_notifier_res');

function rusvc_notifier_export_outfile() {
	$exp_data = get_option('rusvc-notifier-data');
	unset($exp_data['on']);
	if(isset($_GET['exfn']) && !empty($_GET['exfn'])) $exfn = $_GET['exfn']; else $exfn = 'Объявление_'.date('d-m-Y_G-i', time()+10800);
	$s_file = serialize($exp_data);
	header('Content-Description: File Transfer');
	header('Content-type: text/plain');
	header('Content-Disposition: attachment; filename="'.$exfn.'.txt"');
	header('Content-Length: ' . strlen($s_file));
	echo $s_file;
	exit();
}
if( is_admin() ) {
	add_action('wp_ajax_rusvc-notifier-exp-dl', 'rusvc_notifier_export_outfile');
}

function rusvc_notifier_options() {
if(count($_POST)>0) $data = $_POST;
else $data = array();
$c_error = '';
if(isset($_POST['import'])){
    if (is_uploaded_file($_FILES['exf']['tmp_name'])) {
        if($_FILES['exf']['type'] != 'text/plain' || $_FILES['exf']['size'] === 0) {
			$c_error = '<div class="error"><p>Загруженный файл не текстовый или вообще пустой...</p></div>';
		}
		else {
		    $note = fopen($_FILES['exf']['tmp_name'], 'r');
			$data = fread($note, filesize($_FILES['exf']['tmp_name']));
			fclose($note);
			unlink($_FILES['exf']['tmp_name']);
			$data = unserialize($data);
			if( $data === null || !is_array($data)) {
				$c_error = '<div class="error"><p>Файл повреждён, имеет серьёзные ошибки или неправильный формат.</p></div>';
			}
			else {
			    if($newdata = rusvc_notifier_cwd($data)) $data = $newdata;
                else {
                    $data = stripslashes(get_option('rusvc-notifier-data'));
                    $c_error = '<div class="error"><p>Не удалось записать данные.</p></div>';
                }
			}
		}
    }
}
elseif(isset($_POST['save'])) {
    rusvc_notifier_cwd($data);
} else {
    $data = get_option('rusvc-notifier-data');
}
?>
<div class="wrap"><h2>Настройка объявления <a href="#" id="rusvc-notifier-export-clk" class="add-new-h2">Экспорт данных</a> <a href="#" id="rusvc-notifier-import-clk" class="add-new-h2">Импорт данных</a></h2>

<?php echo $c_error; echo $d_err; ?>

<div id="rusvc-notifier-export" style="display:none;">
<h3><?php _e('Экспортировать объявление в файл'); ?></h3>
	<p>
		<button class="button-primary" id="rusvc-notifier-exp-dl"><?php _e('Экспорт'); ?></button>
	</p>
	<hr>
</div>

<div id="rusvc-notifier-import" style="display:none;">
<h3><?php _e('Импортировать объявление из файла'); ?></h3>
	<form method="post" action="" enctype="multipart/form-data">
	    <p>После загрузки файла импорта проверьте все поля формы и поставьте галочку &laquo;Включить показ&raquo;</p>
		<p>
			<input type="file" name="exf" accept="text/plain" />
		</p>
        <p class="submit">
			<input type="submit" name="import" class="button-primary" value="<?php _e('Импорт'); ?>" />
        </p>
	</form>
	<hr>
</div>
    
    <form method="post" action="">
        <table class="form-table">

            <tr valign="top"><th scope="row">Заголовок объявления</th>
                <td><input type="text" name="title" value="<?php echo $data['title']; ?>" size="70"></td></tr>

            <tr valign="top"><td colspan="2"><?php
                $settings = array('media_buttons'=>true, 'textarea_name'=>'text', 'quicktags'=>true, 'tinymce'=>true, 'textarea_rows'=>15 );
                wp_editor( stripslashes($data['text']), 'text', $settings );
            ?></td></tr>

            <tr valign="top"><th scope="row">Важная ссылка</th>
               <td><input type="text" name="link" value="<?php echo $data['link']; ?>" size="70"></td></tr>
               
            <tr valign="top"><th scope="row">Текст ссылки</th>
               <td><input type="text" name="anchor" value="<?php echo $data['anchor']; ?>" size="70"></td></tr>
               
            <tr valign="top"><th scope="row">Открывать ссылку в новом окне</th>
               <td><input type="checkbox" name="linkattr" <?php if(isset($data['linkattr'])) echo 'checked'; ?>></td></tr>
               
            <tr valign="top"><th scope="row">Включить показ</th>
               <td><input type="checkbox" name="on" <?php if(isset($data['on'])) echo 'checked'; ?>></td></tr>
               
            <tr valign="top"><th scope="row">Интервал между показами (в минутах)</th>
               <td><input type="number" name="period" value="<?php echo $data['period']; ?>"><select name="timeunit"><?php 
                    $units = array('m'=>'минуты', 'h'=>'часы', 'd'=>'дни');
                    $selected = '';
                    foreach($units as $u=>$l) {
                        if($data['timeunit'] == $u) $selected = ' selected'; else $selected = '';
                        echo '<option value="'.$u.'"'.$selected.'>'.$l.'</option>';
                    }
            ?></select></td></tr>
			   
            </table>
            
            <p class="submit">
              <input type="submit" name="save" class="button-primary" value="Сохранить" />
            </p>
        </form>
    </div>
<?php }

function rusvc_notifier_cwd($data) {
    if(isset($data['title'])) $data['title'] = htmlspecialchars(trim($data['title'])); else $data['title'] = 'Объявление';
    if(isset($data['anchor'])) $data['anchor'] = htmlspecialchars(trim($data['anchor'])); else $data['anchor'] = '';
    if(isset($data['text'])) $data['text'] = strip_tags(trim($data['text']), '<p><a><em><strong><i><b><img><div><figure><table><th><tr><td><tfoot><thead><pre>'); else $data['text'] = '';
    if(isset($data['link'])) $data['link'] = esc_url_raw(trim($data['link'])); else $data['link'] = '';
    if(isset($data['period']) && !empty($data['period']) && $data['period'] !== 0) $data['period'] = intval($data['period']); else $data['period'] = 1;
    if($data['timeunit'] == 'm') $data['timeunit'] = 'm'; //hm... much powerful!
    elseif($data['timeunit'] == 'h') {
        $data['timeunit'] = 'm';
        $data['period'] = $data['period'] * 60;
    }
    elseif($data['timeunit'] == 'd') {
        $data['timeunit'] = 'm';
        $data['period'] = $data['period'] * 1440;
    }
    else {
        $data['timeunit'] = 'm';
    }
    if(isset($data['linkattr'])) $data['linkattr'] = 1;
    if(isset($data['on'])) $data['on'] = 1;
    unset($data['save']);
    if(update_option('rusvc-notifier-data', $data)) return $data;
    return null;
}

function rusvc_notifier_data_init() {
    return $data = array('title' => 'Объявление', 'text' => '', 'link' => '', 'anchor' => '', 'linkattr' => 1, 'on' => 0, 'period' => 1, 'timeunit' => 'm');
}

function rusvc_notifier_translatetojs() {
    $data = get_option('rusvc-notifier-data');
    $data['text'] = do_shortcode(wptexturize(wpautop(stripslashes($data['text']))));
    $data['text'] = str_replace('"', '\"', $data['text']);
    $data['text'] = str_replace("\n", '', $data['text']);
    echo '<script type="text/javascript">var rusvc_notify = {';
    $i = 0;
    $c = count($data);
    foreach($data as $k => $v){
        //$v = str_replace('/', '\/"', $v);
        echo '"'.$k.'":"'.$v.'"';
        $i++;
        if($i < $c) echo ',';
    }
    echo '}</script>';
}

if(!is_admin()) add_action('wp_head', 'rusvc_notifier_translatetojs');

function rusvc_notifier_delete() {
    del_option('rusvc-notifier-data');
}
register_uninstall_hook(__FILE__, 'rusvc_notifier_delete');

function rusvc_notifier_act() {
    $data = rusvc_notifier_data_init();
    add_option('rusvc-notifier-data', $data);
}
register_activation_hook(__FILE__, 'rusvc_notifier_act');

?>
